# 注释

**Comments**


所有程序员都努力使自己的代码易于理解，但有时也需要一些额外的解释。在这种情况下，程序员会在源代码中留下 *注释，comments*，编译器会忽略这些注释，但阅读源代码的人可能会发现有用。

下面就是个简单的注释：

```rust
// hello, world
```


在 Rust 中，惯用的注释风格，以两个斜线开始一条注释，而该注释会一直持续到行尾。对于超出单个行的注释，咱们需要在每一行，都包含 `//`，像下面这样：


```rust
// 所以我们要做的事情很复杂，长到我们需要
// 多行注释来完成！呼！希望这条注释能
// 解释发生了什么。
```


注释也可以放在包含了代码行的末尾：


文件名：`src/main.rs`

```rust
fn main() {
    let lucky_number = 7; // 今天我感受到了好运
}
```

但咱们更经常看到的是，将注释放在其所注释代码上方单独一行，这种形式：


文件名：`src/main.rs`

```rust
fn main() {
    // 今日感到幸运
    let lucky_number = 7;
}
```

Rust 还有另一种注释，即文档注释，documentation comments，我们将在第 14 章 [“将 Crate 发布到 Crates.io”](../crates-io/publishing.md) 一节中讨论。
